<template>
  <meta charset="UTF-8" />
  <Header />

  <h2>Disclaimer</h2>
  <p id="disclaimer-text">
    <b
      >Dieser Software Prototyp ist darauf beschränkt vorherzusagen, zwischen
      welchen Knoten eines Netzwerks in Zukunft Kanten entstehen werden. Dabei
      wird sich auf ungerichtete und ungewichtete Graphen beschränkt.
      Multigraphen werden ebenfalls ausgeschlossen.</b
    >
  </p>

  <h2>Durchführen von Kantenvorhersagen</h2>
  <NetworkAlgorithmSelection
    id="network-algorithm-selection"
    v-bind:undo_select_algorithm="resetDropdownAlgorithm"
    @network_selection_changed="loadNetwork($event)"
    @algorithm_selection_changed="loadAlgorithm($event)"
  />

  <table>
    <tr>
      <td>
        <Graph
          v-if="!display_evaluation_report && network_selected"
          v-bind:network_data_json="displayed_network"
          v-bind:display_result="display_result_network"
          v-bind:display_all_network_informations="
            displayAllNetworkInformations
          "
          v-bind:selected_algorithm="selected_algorithm"
          v-bind:loaded_original_network="loaded_original_network"
          v-bind:loaded_result_network="loaded_result_network"
          v-bind:loaded_betweenness_cantralization="
            loadedBetweennessCentralization
          "
          v-bind:loaded_degree_centralization="loadedDegreeCentralization"
          v-bind:loaded_avg_effective_size="loadedAvgEffectiveSize"
          v-bind:betweenness_centralization="betweennessCentralization"
          v-bind:degree_centralization="degreeCentralization"
          v-bind:avg_effective_size="avgEffectiveSize"
        />
        <EvaluationReport
          v-else-if="display_evaluation_report"
          v-bind:evaluation_values="evaluation_values"
        />
      </td>
      <td>
        <Explanation
          v-if="algorithm_seleted"
          v-bind:json_object_explanations="json_object_explanations"
          v-bind:reset_explanation_index="resetExplanationIndex"
          v-bind:reset_algorithm_started="resetAlgorithmStarted"
          v-bind:selected_network="selected_network"
          @start_algorithm="startAlgorithm($event)"
          @display_roc="changeDisplayEvaluationReport($event)"
          @display_resut_network="changeDisplayedNetwork($event)"
          @left_first_explanation_page="hideAllNetworkInformations($event)"
          @entered_first_explanation_page="showAllNetworkInformations($event)"
        />
      </td>
    </tr>
  </table>

  <h2>Fragen zum Nachschlagen</h2>
  <div class="component">
    <Accordion />
  </div>
</template>

<script>
import Header from "./components/basic/Header.vue";
import EvaluationReport from "./components/EvaluationReport.vue";
import Explanation from "./components/Explanation.vue";
import Graph from "./components/Graph.vue";
import NetworkAlgorithmSelection from "./components/NetworkAlgorithmSelection.vue";
import Accordion from "./components/Accordion.vue";

export default {
  name: "App",
  components: {
    Header,
    Graph,
    EvaluationReport,
    Explanation,
    NetworkAlgorithmSelection,
    Accordion,
  },
  data() {
    return {
      backendUrl: "http://127.0.0.1:5000",

      resetExplanationIndex: false,
      resetDropdownAlgorithm: false,
      resetAlgorithmStarted: false,

      json_object_original_network: null,
      json_object_explanations: null,
      json_object_result_network: null,

      betweennessCentralization: -1,
      degreeCentralization: -1,
      avgEffectiveSize: -1,

      displayed_network: null,

      display_evaluation_report: false,
      display_result_network: false,
      displayAllNetworkInformations: true,

      selected_algorithm: "no-selection",
      selected_network: "no-selection",
      algorithm_seleted: false,
      network_selected: false,

      abortControllerResultRequest: new AbortController(),

      loaded_original_network: false,
      loaded_result_network: false,
      loadedBetweennessCentralization: false,
      loadedDegreeCentralization: false,
      loadedAvgEffectiveSize: false,
    };
  },
  computed: {
    evaluation_values: function () {
      if (this.json_object_result_network != null) {
        return this.json_object_result_network.evaluation;
      }
      return null;
    },
    abortControllerResultRequestSignal: function () {
      return this.abortControllerResultRequest.signal;
    },
  },
  watch: {
    json_object_original_network: function () {
      if (this.json_object_original_network != null) {
        this.displayed_network = this.json_object_original_network;
      }
    },
    json_object_result_network: function () {
      if (
        this.json_object_result_network != null &&
        this.display_result_network
      ) {
        this.displayed_network = this.json_object_result_network;
      }
    },
  },
  methods: {
    changeDisplayEvaluationReport(newValue) {
      this.display_evaluation_report = newValue;
    },
    changeDisplayedNetwork(displayResultNetwork) {
      if (displayResultNetwork) {
        this.display_result_network = true;
        if (this.json_object_result_network != null) {
          this.displayed_network = this.json_object_result_network;
        } else {
          this.displayed_network = null;
        }
      } else {
        this.display_result_network = false;
        this.displayed_network = this.json_object_original_network;
      }
    },
    setButtonDisabled(buttonId, disabled) {
      var button;
      if (buttonId == "next") {
        button = document.getElementById("btn_next");
      } else if (buttonId == "back") {
        button = document.getElementById("btn_back");
      }

      if (button != null) {
        button.disabled = disabled;
      }
    },
    resetExplanations() {
      this.setButtonDisabled("back", true);
      this.setButtonDisabled("next", false);
    },
    clearExplanations() {
      this.setButtonDisabled("back", true);
      this.setButtonDisabled("next", true);
      this.json_object_explanations = null;
      this.resetDropdownAlgorithm = !this.resetDropdownAlgorithm;
    },
    resetNetwork() {
      this.displayed_network = this.json_object_original_network;
      this.json_object_result_network = null;
      this.display_result_network = false;
      this.display_evaluation_report = false;
    },
    clearNetwork() {
      this.displayed_network = null;
      this.json_object_original_network = null;
      this.json_object_result_network = null;
      this.display_result_network = false;
      this.display_evaluation_report = false;
    },
    resetNetworkProperties() {
      this.loadedBetweennessCentralization = false;
      this.loadedDegreeCentralization = false;
      this.loadedAvgEffectiveSize = false;
      this.displayAllNetworkInformations = true;
      this.betweennessCentralization = -1;
      this.degreeCentralization = -1;
      this.avgEffectiveSize = -1;
    },

    loadNetwork(network) {
      if (this.selected_network != "no-selection") {
        this.abortControllerResultRequest.abort();
        this.abortControllerResultRequest = new AbortController();
        this.resetAlgorithmStarted = !this.resetAlgorithmStarted;
        this.resetExplanationIndex = !this.resetExplanationIndex;
      }

      this.clearNetwork();
      this.selected_network = network;
      this.resetNetworkProperties();

      if (network != "no-selection") {
        this.requestGraphAsJson();
        this.requestBetweennessCentralization();
        this.requestDegreeCentralization();
        this.requestAverageEffectiveSize();
        this.resetExplanations();
        this.network_selected = true;
      } else {
        this.network_selected = false;
        if (this.selectedAlgorithm != "no-selection") {
          this.resetExplanations();
          this.setButtonDisabled("next", true);
        }
      }
    },
    requestGraphAsJson: async function () {
      this.loaded_original_network = false;
      fetch(this.backendUrl + "/original-network/" + this.selected_network)
        .then((response) => response.json())
        .then((data) => {
          if ("error" in data) {
            alert("Invalid network.");
            this.clearNetwork();
          } else {
            this.json_object_original_network = data;
            this.loaded_original_network = true;
            console.log("received graph json");
          }
        })
        .catch(function (error) {
          this.loaded_original_network = true;
          console.log("error(s):", error.message);
          alert("An error occured loading network. Please reload site.");
        });
    },

    loadAlgorithm(algorithm) {
      if (this.selected_algorithm != "no-selection") {
        this.abortControllerResultRequest.abort();
        this.abortControllerResultRequest = new AbortController();
        this.resetAlgorithmStarted = !this.resetAlgorithmStarted;
        this.resetExplanationIndex = !this.resetExplanationIndex;
      }

      this.selected_algorithm = algorithm;

      if (algorithm != "no-selection") {
        this.algorithm_seleted = true;
        this.resetExplanations();
        this.resetNetwork();
        this.requestExplanation();
      } else {
        this.algorithm_seleted = false;
        this.clearExplanations();
        this.resetNetwork();
      }
    },
    requestExplanation: async function () {
      fetch(this.backendUrl + "/explanations/" + this.selected_algorithm)
        .then((response) => response.json())
        .then((data) => {
          if ("error" in data) {
            alert("Invalid algorithm.");
            this.algorithm_seleted = false;
            this.clearExplanations();
          } else {
            this.json_object_explanations = data;
            this.setButtonDisabled("back", true);
          }
        })
        .catch(function (error) {
          console.log("error(s):", error.message);
          alert("An error occured loading explanations. Please reload site.");
        });
    },

    startAlgorithm: async function () {
      this.displayAllNetworkInformations = false;
      this.abortControllerResultRequest.abort();
      this.abortControllerResultRequest = new AbortController();
      this.json_object_result_network = null;
      this.loaded_result_network = false;
      fetch(
        this.backendUrl +
          "/start-algorithm/" +
          this.selected_algorithm +
          "/" +
          this.selected_network,
        {
          signal: this.abortControllerResultRequestSignal,
        }
      )
        .then((response) => response.json())
        .then((data) => {
          this.json_object_result_network = data;
          this.loaded_result_network = true;
        })
        .catch(function (error) {
          if (error.name == "AbortError") {
            console.log("fetch aborted");
            this.loaded_result_network = true;
          } else {
            console.log("error(s):", error.message);
            this.loaded_result_network = true;
            alert("An error occured loading result. Please reload site.");
          }
        });
    },
    requestBetweennessCentralization: async function () {
      fetch(
        this.backendUrl +
          "/network-characteristic/betweenness-centralization/" +
          this.selected_network,
        {
          signal: this.abortControllerResultRequestSignal,
        }
      )
        .then((response) => response.json())
        .then((data) => {
          if ("error" in data) {
            alert("Invalid network.");
          } else {
            this.betweennessCentralization = data.betweenness_centralization;
            this.loadedBetweennessCentralization = true;
            console.log("received betweenness centralization");
          }
        })
        .catch(function (error) {
          if (error.name == "AbortError") {
            console.log("fetch betweenness centralization aborted");
          } else {
            console.log("error(s):", error.message);
            alert(
              "An error occured loading betweenness centralization. Please reload site."
            );
          }
        });
    },
    requestDegreeCentralization: async function () {
      fetch(
        this.backendUrl +
          "/network-characteristic/degree-centralization/" +
          this.selected_network,
        {
          signal: this.abortControllerResultRequestSignal,
        }
      )
        .then((response) => response.json())
        .then((data) => {
          if ("error" in data) {
            alert("Invalid network.");
          } else {
            this.degreeCentralization = data.degree_centralization;
            this.loadedDegreeCentralization = true;
            console.log("received degree centralization");
          }
        })
        .catch(function (error) {
          if (error.name == "AbortError") {
            console.log("fetch degree centralization aborted");
          } else {
            console.log("error(s):", error.message);
            alert(
              "An error occured loading degree centralization. Please reload site."
            );
          }
        });
    },
    requestAverageEffectiveSize: async function () {
      fetch(
        this.backendUrl +
          "/network-characteristic/average-effective-size/" +
          this.selected_network,
        {
          signal: this.abortControllerResultRequestSignal,
        }
      )
        .then((response) => response.json())
        .then((data) => {
          if ("error" in data) {
            alert("Invalid network.");
          } else {
            this.avgEffectiveSize = data.avg_effective_size;
            this.loadedAvgEffectiveSize = true;
            console.log("received avg effective size");
          }
        })
        .catch(function (error) {
          if (error.name == "AbortError") {
            console.log("fetch avg effective size aborted");
          } else {
            console.log("error(s):", error.message);
            alert(
              "An error occured loading avg effective size. Please reload site."
            );
          }
        });
    },

    hideAllNetworkInformations: function () {
      this.displayAllNetworkInformations = false;
    },
    showAllNetworkInformations: function () {
      this.displayAllNetworkInformations = true;
    },
  },
};
</script>

<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  color: #2c3e50;
  margin-top: 0px;
}

body {
  background-color: whitesmoke;
  margin: 0px;
}

.card {
  border-radius: 5px;
  box-shadow: 0 0 10px grey;
  font-size: 17px;
  background-color: white;
  padding: 16px;
}

.card .title {
  color: black;
  font-size: 21px;
  margin-bottom: 10px;
}

.card .subtitle {
  color: gray;
  font-size: 17px;
  margin-bottom: 16px;
}

.card button {
  background: transparent;
  padding: 10px 20px;
  font-size: 17px;
  border: 2px solid transparent;
  float: right;
  color: #1e94cc;
}

.card button:disabled {
  background: transparent;
  padding: 10px 20px;
  font-size: 17px;
  border: 2px solid transparent;
  float: right;
  color: rgb(143, 153, 170);
}

.component_flex_end {
  margin-left: 5px;
}

.component_flex_start {
  margin-right: 5px;
}
</style>

<style scoped>
#disclaimer-text {
  margin: 0px 10px;
}

#network-algorithm-selection {
  margin: 0px 10px;
}

td {
  max-width: 50%;
  width: 50%;
  max-width: 50vw;
  vertical-align: top;
  padding: 5px;
}

table {
  width: 100%;
  height: 100%;
}

.component {
  margin-left: 10px;
  margin-right: 10px;
  margin-bottom: 10px;
  border-radius: 5px;
}

h2 {
  margin-left: 10px;
  margin-right: 10px;
}
</style>
